| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Public Attributes | Private Types | Private Member Functions | Private Attributes | List of all members
PartPropSvc Class Reference

`#include <src/PartPropSvc.h>`

Inheritance diagram for PartPropSvc:
[legend]
Collaboration diagram for PartPropSvc:
[legend]

## Public Member Functions
StatusCode | initialize () override
StatusCode | finalize () override
HepPDT::ParticleDataTable * | PDT () override
void | setUnknownParticleHandler (HepPDT::ProcessUnknownID *, const std::string &) override
Public Member Functions inherited from extends< Service, IPartPropSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Public Attributes
| InputFile

## Private Types
using | inputFunPtr = bool(*)(std::istream &, HepPDT::TableBuilder &)

## Private Member Functions
StatusCode | createTable ()
inputFunPtr | parseTableType (const std::string &)

## Private Attributes
std::vector< std::pair< std::string, inputFunPtr > > | m_inputs
Gaudi::Property< std::string > | m_pdtFiles {this, "InputFile", "PDGTABLE.MeV"}
HepPDT::ProcessUnknownID * | m_upid = nullptr
std::string | m_upid_name
std::optional< HepPDT::ParticleDataTable > | m_pdt
bool | m_upid_local = false

## Additional Inherited Members
Public Types inherited from extends< Service, IPartPropSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 28 of file PartPropSvc.h.

## Member Typedef Documentation

## ◆ inputFunPtr

using PartPropSvc::inputFunPtr = bool ( * )( std::istream&, HepPDT::TableBuilder& )
| private

Definition at line 41 of file PartPropSvc.h.

## Member Function Documentation

## ◆ createTable()

StatusCode PartPropSvc::createTable | ( |  | ) |
| private

Definition at line 125 of file PartPropSvc.cpp.

125 {
126
127 // use a handler for unknown heavy ions
128 if ( !m_upid ) {
129 setUnknownParticleHandler( new HepPDT::HeavyIonUnknownID, "Default Heavy Ion Handler" );
130 m_upid_local = true;
131 }
132
133 m_pdt.emplace( m_upid_name, m_upid );
134
135 HepPDT::TableBuilder tb( *m_pdt );
136
137 for ( const auto& itr : m_inputs ) {
138 const auto& f = itr.first;
139 const auto& pF = itr.second;
140
141 debug() << "Reading PDT file \"" << f << "\"" << endmsg;
142
143 std::ifstream pdfile{f};
144 // build a table from the file
145 if ( !pF( pdfile, tb ) ) {
146 error() << "Error reading PDT file: \"" << f << "\"" << endmsg;
147 return StatusCode::FAILURE;
148 }
149 }
150
151 return StatusCode::SUCCESS;
152 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
PartPropSvc::m_inputs
std::vector< std::pair< std::string, inputFunPtr > > m_inputs
Definition: PartPropSvc.h:44
PartPropSvc::m_upid
HepPDT::ProcessUnknownID * m_upid
Definition: PartPropSvc.h:48
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
PartPropSvc::m_upid_local
bool m_upid_local
Definition: PartPropSvc.h:55
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
PartPropSvc::m_pdt
std::optional< HepPDT::ParticleDataTable > m_pdt
Definition: PartPropSvc.h:51
PartPropSvc::setUnknownParticleHandler
void setUnknownParticleHandler(HepPDT::ProcessUnknownID *, const std::string &) override
Definition: PartPropSvc.cpp:171
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
std::ifstream
STL class.
PartPropSvc::m_upid_name
std::string m_upid_name
Definition: PartPropSvc.h:49

## ◆ finalize()

StatusCode PartPropSvc::finalize | ( |  | ) |
| override

Definition at line 88 of file PartPropSvc.cpp.

88 {
89
90 m_pdt.reset();
91
92 if ( m_upid_local && m_upid ) {
93 m_upid_local = false;
94 // This will cause a memory leak, but we can't delete it as the
95 // destructor of HepPDT::processUnknownID is protected.
96 // We need this though to call reinitialize successfully.
97 m_upid = nullptr;
98 }
99
100 StatusCode status = Service::finalize();
101
102 if ( status.isSuccess() ) { debug() << "Service finalised successfully" << endmsg; }
103
104 return status;
105 }
Service::finalize
StatusCode finalize() override
Definition: Service.cpp:164
PartPropSvc::m_upid
HepPDT::ProcessUnknownID * m_upid
Definition: PartPropSvc.h:48
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
PartPropSvc::m_upid_local
bool m_upid_local
Definition: PartPropSvc.h:55
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
PartPropSvc::m_pdt
std::optional< HepPDT::ParticleDataTable > m_pdt
Definition: PartPropSvc.h:51
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ initialize()

StatusCode PartPropSvc::initialize | ( |  | ) |
| override

Definition at line 22 of file PartPropSvc.cpp.

22 {
23
24 StatusCode status = Service::initialize();
25
26 if ( status.isFailure() ) {
27 error() << "Could not initialize main svc" << endmsg;
28 return StatusCode::FAILURE;
29 }
30
31 std::string key = m_pdtFiles.value();
32
33 typedef boost::tokenizer<boost::char_separator<char>> tokenizer;
34 boost::char_separator<char> sep( ", " );
35 boost::char_separator<char> sep_eq( "=" );
36
37 tokenizer tokens( key, sep );
38 for ( auto it = tokens.begin(); it != tokens.end(); ++it ) {
39
40 tokenizer tok2( *it, sep_eq );
41 int nToks( std::distance( tok2.begin(), tok2.end() ) );
42
43 auto it2 = tok2.begin();
44 const std::string fname = *it2;
45 std::string fmt;
46 if ( nToks == 1 ) {
47 info() << "No table format type specified for \"" << fname << "\". Assuming PDG" << endmsg;
48 fmt = "PDG";
49 } else {
50 ++it2;
51 fmt = *it2;
52 }
53
54 // see if input file exists in $DATAPATH
55 std::string rfile = System::PathResolver::find_file( fname, "DATAPATH" );
56 if ( rfile.empty() ) {
57 error() << "Could not find PDT file: \"" << fname << "\" in $DATAPATH" << endmsg;
58 return StatusCode::FAILURE;
59 }
60
61 // is the file readable?
62 std::ifstream pdfile{rfile};
63 if ( !pdfile ) {
64 error() << "Could not open PDT file: \"" << rfile << "\"" << endmsg;
65 return StatusCode::FAILURE;
66 }
67
68 std::string FMT = boost::algorithm::to_upper_copy( fmt );
69
70 inputFunPtr pF = nullptr;
71 try {
72 pF = parseTableType( FMT );
73 } catch ( ... ) {
74 error() << "Could not determine Particle Property table type: \"" << FMT << "\" for file \"" << fname << "\""
75 << endmsg;
76 return StatusCode::FAILURE;
77 }
78
79 debug() << "Adding PDT file \"" << rfile << "\" type " << FMT << endmsg;
80
81 m_inputs.emplace_back( rfile, pF );
82 }
83
84 return status;
85 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:60
std::string::empty
T empty(T... args)
std::distance
T distance(T... args)
PartPropSvc::parseTableType
inputFunPtr parseTableType(const std::string &)
Definition: PartPropSvc.cpp:109
PartPropSvc::inputFunPtr
bool(*)(std::istream &, HepPDT::TableBuilder &) inputFunPtr
Definition: PartPropSvc.h:41
PartPropSvc::m_pdtFiles
Gaudi::Property< std::string > m_pdtFiles
Definition: PartPropSvc.h:46
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
PartPropSvc::m_inputs
std::vector< std::pair< std::string, inputFunPtr > > m_inputs
Definition: PartPropSvc.h:44
std::string
STL class.
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
System::PathResolver::find_file
static std::string find_file(const std::string &logical_file_name, const std::string &search_path, SearchType search_type=LocalSearch)
Definition: PathResolver.cpp:108
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
std::ifstream
STL class.
std::vector::emplace_back
T emplace_back(T... args)

## ◆ parseTableType()

PartPropSvc::inputFunPtr PartPropSvc::parseTableType | ( | const std::string & | typ | ) |
| private

Definition at line 109 of file PartPropSvc.cpp.

109 {
110 static const auto table = {
111 std::make_pair( "PDG", &HepPDT::addPDGParticles ), std::make_pair( "PYTHIA", &HepPDT::addPythiaParticles ),
112 std::make_pair( "EVTGEN", &HepPDT::addEvtGenParticles ), std::make_pair( "HERWIG", &HepPDT::addHerwigParticles ),
113 std::make_pair( "ISAJET", &HepPDT::addIsajetParticles ), std::make_pair( "QQ", &HepPDT::addQQParticles )};
114 auto i = std::find_if( std::begin( table ), std::end( table ),
115 [&]( const std::pair<const char*, inputFunPtr>& p ) { return typ == p.first; } );
116 if ( i == std::end( table ) ) {
117 error() << "Unknown Particle Data file type: \"" << typ << "\"" << endmsg;
118 throw std::runtime_error( "error parsing particle table type" );
119 }
120 return i->second;
121 }
std::end
T end(T... args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
std::runtime_error
STL class.
std::make_pair
T make_pair(T... args)
std::pair
std::find_if
T find_if(T... args)
std::begin
T begin(T... args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ PDT()

HepPDT::ParticleDataTable * PartPropSvc::PDT | ( |  | ) |
| override

Definition at line 156 of file PartPropSvc.cpp.

156 {
157
158 if ( !m_pdt ) {
159 debug() << "creating ParticleDataTable" << endmsg;
160 if ( createTable().isFailure() ) {
161 fatal() << "Could not create ParticleDataTable" << endmsg;
162 m_pdt.reset();
163 }
164 }
165
166 return m_pdt ? &m_pdt.value() : nullptr;
167 }
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
PartPropSvc::createTable
StatusCode createTable()
Definition: PartPropSvc.cpp:125
PartPropSvc::m_pdt
std::optional< HepPDT::ParticleDataTable > m_pdt
Definition: PartPropSvc.h:51
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:92
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ setUnknownParticleHandler()

void PartPropSvc::setUnknownParticleHandler | ( | HepPDT::ProcessUnknownID * | puid,
|  | const std::string & | n
| ) |  |
| override

Definition at line 171 of file PartPropSvc.cpp.

171 {
172 if ( m_pdt ) {
173 error() << "not setting Unknown Particle Handler \"" << n << "\" as ParticleDataTable already instantiated"
174 << endmsg;
175 return;
176 }
177
178 debug() << "setting Unknown Particle Handler \"" << n << "\" at " << puid << endmsg;
179
180 if ( m_upid ) {
181 warning() << "overriding previously selected Unknown Particle Handler \"" << m_upid_name << "\" with \"" << n
182 << "\"" << endmsg;
183 }
184
185 m_upid = puid;
186 m_upid_name = n;
187 }
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:101
PartPropSvc::m_upid
HepPDT::ProcessUnknownID * m_upid
Definition: PartPropSvc.h:48
GaudiPluginService.cpluginsvc.n
n
Definition: cpluginsvc.py:210
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
PartPropSvc::m_pdt
std::optional< HepPDT::ParticleDataTable > m_pdt
Definition: PartPropSvc.h:51
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
PartPropSvc::m_upid_name
std::string m_upid_name
Definition: PartPropSvc.h:49

## Member Data Documentation

## ◆ InputFile

PartPropSvc.InputFile

Definition at line 6 of file PartPropSvc.py.

## ◆ m_inputs

std::vector<std::pair<std::string, inputFunPtr> > PartPropSvc::m_inputs
| private

Definition at line 44 of file PartPropSvc.h.

## ◆ m_pdt

std::optional<HepPDT::ParticleDataTable> PartPropSvc::m_pdt
| private

Definition at line 51 of file PartPropSvc.h.

## ◆ m_pdtFiles

Gaudi::Property<std::string> PartPropSvc::m_pdtFiles {this, "InputFile", "PDGTABLE.MeV"}
| private

Definition at line 46 of file PartPropSvc.h.

## ◆ m_upid

HepPDT::ProcessUnknownID* PartPropSvc::m_upid = nullptr
| private

Definition at line 48 of file PartPropSvc.h.

## ◆ m_upid_local

bool PartPropSvc::m_upid_local = false
| private

Definition at line 55 of file PartPropSvc.h.

## ◆ m_upid_name

std::string PartPropSvc::m_upid_name
| private

Definition at line 49 of file PartPropSvc.h.

The documentation for this class was generated from the following files:

- PartPropSvc/src/PartPropSvc.h
- PartPropSvc/share/PartPropSvc.py
- PartPropSvc/src/PartPropSvc.cpp